var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ElementRef, ViewContainerRef, ChangeDetectionStrategy, Renderer2, Optional, ContentChild } from '@angular/core';
import { ComponentBase, applyMixins, setValue } from '@syncfusion/ej2-ng-base';
import { ListView, Virtualization } from '@syncfusion/ej2-lists';
import { Template } from '@syncfusion/ej2-ng-base';
export var inputs = ['animation', 'checkBoxPosition', 'cssClass', 'dataSource', 'enable', 'enablePersistence', 'enableRtl', 'enableVirtualization', 'fields', 'groupTemplate', 'headerTemplate', 'headerTitle', 'height', 'htmlAttributes', 'locale', 'query', 'showCheckBox', 'showHeader', 'showIcon', 'sortOrder', 'template', 'width'];
export var outputs = ['actionBegin', 'actionComplete', 'actionFailure', 'select'];
export var twoWays = [''];
/**
 * Represents Angular ListView Component
 * ```
 * <ejs-listview [dataSource]='data'></ejs-listview>
 * ```
 */
var ListViewComponent = /** @class */ (function (_super) {
    __extends(ListViewComponent, _super);
    function ListViewComponent(ngEle, srenderer, viewContainerRef, virtualization) {
        var _this = _super.call(this) || this;
        _this.ngEle = ngEle;
        _this.srenderer = srenderer;
        _this.viewContainerRef = viewContainerRef;
        _this.element = _this.ngEle.nativeElement;
        _this.injectedModules = _this.injectedModules || [];
        for (var i = 3; i < arguments.length; i++) {
            var injectedObj = arguments[i];
            if (injectedObj) {
                _this.injectedModules.push(injectedObj);
            }
        }
        _this.registerEvents(outputs);
        _this.addTwoWay.call(_this, twoWays);
        setValue('currentInstance', _this, _this.viewContainerRef);
        return _this;
    }
    ListViewComponent.prototype.ngOnInit = function () {
    };
    ListViewComponent.prototype.ngAfterViewInit = function () {
    };
    ListViewComponent.prototype.ngOnDestroy = function () {
    };
    ListViewComponent.prototype.ngAfterContentChecked = function () {
    };
    ListViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ejs-listview',
                    inputs: inputs,
                    outputs: outputs,
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    queries: {}
                },] },
    ];
    /** @nocollapse */
    ListViewComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
        { type: ViewContainerRef, },
        { type: Virtualization, decorators: [{ type: Optional },] },
    ]; };
    ListViewComponent.propDecorators = {
        'template': [{ type: ContentChild, args: ['template',] },],
        'groupTemplate': [{ type: ContentChild, args: ['groupTemplate',] },],
        'headerTemplate': [{ type: ContentChild, args: ['headerTemplate',] },],
    };
    __decorate([
        Template(),
        __metadata("design:type", Object)
    ], ListViewComponent.prototype, "template", void 0);
    __decorate([
        Template(),
        __metadata("design:type", Object)
    ], ListViewComponent.prototype, "groupTemplate", void 0);
    __decorate([
        Template(),
        __metadata("design:type", Object)
    ], ListViewComponent.prototype, "headerTemplate", void 0);
    return ListViewComponent;
}(ListView));
export { ListViewComponent };
applyMixins(ListViewComponent, [ComponentBase]);
export var VirtualizationService = { provide: Virtualization, useValue: Virtualization };
//# sourceMappingURL=listview.component.js.map